VMware vSphere Automation SDK for .NET 6.5.0

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions
vmware::vcenter::VMStub Class Reference

Remote stub implementation of the VM API service. More...

Inherits vmware::vcenter::VM.

List of all members.

## Public Member Functions
| VMStub (vmware.vapi.core.IApiProvider iApiProvider, vmware.vapi.bindings.IStubConfiguration config)
string | Create (vmware.vcenter.VMTypes.CreateSpec spec)
| Creates a virtual machine.
string | Create (vmware.vcenter.VMTypes.CreateSpec spec, global::System.Action< vmware.vapi.std.Progress > _progress, vmware.vapi.bindings.client.InvocationConfig _invocationConfig)
| Creates a virtual machine.
global::System.Threading.Tasks.Task < string > | CreateAsync (vmware.vcenter.VMTypes.CreateSpec spec)
| Creates a virtual machine.
global::System.Threading.Tasks.Task < string > | CreateAsync (vmware.vcenter.VMTypes.CreateSpec spec, global::System.Action< vmware.vapi.std.Progress > _progress, vmware.vapi.bindings.client.InvocationConfig _invocationConfig)
| Creates a virtual machine.
vmware.vcenter.VMTypes.Info | Get (string vm)
| Returns information about a virtual machine.
vmware.vcenter.VMTypes.Info | Get (string vm, global::System.Action< vmware.vapi.std.Progress > _progress, vmware.vapi.bindings.client.InvocationConfig _invocationConfig)
| Returns information about a virtual machine.
global::System.Threading.Tasks.Task < vmware.vcenter.VMTypes.Info > | GetAsync (string vm)
| Returns information about a virtual machine.
global::System.Threading.Tasks.Task < vmware.vcenter.VMTypes.Info > | GetAsync (string vm, global::System.Action< vmware.vapi.std.Progress > _progress, vmware.vapi.bindings.client.InvocationConfig _invocationConfig)
| Returns information about a virtual machine.
void | Delete (string vm)
| Deletes a virtual machine.
void | Delete (string vm, global::System.Action< vmware.vapi.std.Progress > _progress, vmware.vapi.bindings.client.InvocationConfig _invocationConfig)
| Deletes a virtual machine.
global::System.Threading.Tasks.Task | DeleteAsync (string vm)
| Deletes a virtual machine.
global::System.Threading.Tasks.Task | DeleteAsync (string vm, global::System.Action< vmware.vapi.std.Progress > _progress, vmware.vapi.bindings.client.InvocationConfig _invocationConfig)
| Deletes a virtual machine.
global::System.Collections.Generic.List < vmware.vcenter.VMTypes.Summary > | List (vmware.vcenter.VMTypes.FilterSpec filter)
| Returns information about at most 1000 visible (subject to permission checks) virtual machines in vCenter matching the VM.FilterSpec .
global::System.Collections.Generic.List < vmware.vcenter.VMTypes.Summary > | List (vmware.vcenter.VMTypes.FilterSpec filter, global::System.Action< vmware.vapi.std.Progress > _progress, vmware.vapi.bindings.client.InvocationConfig _invocationConfig)
| Returns information about at most 1000 visible (subject to permission checks) virtual machines in vCenter matching the VM.FilterSpec .
global::System.Threading.Tasks.Task < global::System.Collections.Generic.List < vmware.vcenter.VMTypes.Summary > > | ListAsync (vmware.vcenter.VMTypes.FilterSpec filter)
| Returns information about at most 1000 visible (subject to permission checks) virtual machines in vCenter matching the VM.FilterSpec .
global::System.Threading.Tasks.Task < global::System.Collections.Generic.List < vmware.vcenter.VMTypes.Summary > > | ListAsync (vmware.vcenter.VMTypes.FilterSpec filter, global::System.Action< vmware.vapi.std.Progress > _progress, vmware.vapi.bindings.client.InvocationConfig _invocationConfig)
| Returns information about at most 1000 visible (subject to permission checks) virtual machines in vCenter matching the VM.FilterSpec .

## Detailed Description

Remote stub implementation of the VM API service.

## Constructor & Destructor Documentation

vmware::vcenter::VMStub::VMStub | ( | vmware.vapi.core.IApiProvider | iApiProvider,
|  | vmware.vapi.bindings.IStubConfiguration | config
| ) |  | `[inline]`

## Member Function Documentation

string vmware::vcenter::VMStub::Create | ( | vmware.vcenter.VMTypes.CreateSpec | spec | ) | `[inline]`

Creates a virtual machine.

Exceptions:

  vmware.vapi.std.errors.AlreadyExists | if a virtual machine with the specified name already exists.
  vmware.vapi.std.errors.Error | if the system reports an error while responding to the request.
  vmware.vapi.std.errors.InvalidArgument | if any of the specified parameters are invalid.
  vmware.vapi.std.errors.NotFound | if any of the resources specified in spec could not be found
  vmware.vapi.std.errors.ResourceInaccessible | if a specified resource (eg. host) is not accessible.
  vmware.vapi.std.errors.ResourceInUse | if any of the specified storage addresses (eg. IDE, SATA, SCSI) result in a storage address conflict.
  vmware.vapi.std.errors.ServiceUnavailable | if the system is unable to communicate with a service to complete the request.
  vmware.vapi.std.errors.UnableToAllocateResource | if any of the resources needed to create the virtual machine could not be allocated.
  vmware.vapi.std.errors.Unauthenticated | if the user can not be authenticated.
  vmware.vapi.std.errors.Unauthorized | if the user doesn't have the required privileges.
  vmware.vapi.std.errors.Unsupported | if `guestOS` is not supported for the requested virtual hardware version and spec includes null fields that default to guest-specific values.

Parameters:

  spec | Virtual machine specification.

Returns:
  ID of newly-created virtual machine. The result will be an identifier for the resource type: `VirtualMachine` .

Implements vmware::vcenter::VM.

string vmware::vcenter::VMStub::Create | ( | vmware.vcenter.VMTypes.CreateSpec | spec,
|  | global::System.Action< vmware.vapi.std.Progress > | _progress,
|  | vmware.vapi.bindings.client.InvocationConfig | _invocationConfig
| ) |  | `[inline]`

Creates a virtual machine.

Exceptions:

  vmware.vapi.std.errors.AlreadyExists | if a virtual machine with the specified name already exists.
  vmware.vapi.std.errors.Error | if the system reports an error while responding to the request.
  vmware.vapi.std.errors.InvalidArgument | if any of the specified parameters are invalid.
  vmware.vapi.std.errors.NotFound | if any of the resources specified in spec could not be found
  vmware.vapi.std.errors.ResourceInaccessible | if a specified resource (eg. host) is not accessible.
  vmware.vapi.std.errors.ResourceInUse | if any of the specified storage addresses (eg. IDE, SATA, SCSI) result in a storage address conflict.
  vmware.vapi.std.errors.ServiceUnavailable | if the system is unable to communicate with a service to complete the request.
  vmware.vapi.std.errors.UnableToAllocateResource | if any of the resources needed to create the virtual machine could not be allocated.
  vmware.vapi.std.errors.Unauthenticated | if the user can not be authenticated.
  vmware.vapi.std.errors.Unauthorized | if the user doesn't have the required privileges.
  vmware.vapi.std.errors.Unsupported | if `guestOS` is not supported for the requested virtual hardware version and spec includes null fields that default to guest-specific values.

Parameters:

  spec | Virtual machine specification.
  _progress | Progress notification call back
  _invocationConfig | Configuration for the method invocation

Returns:
  ID of newly-created virtual machine. The result will be an identifier for the resource type: `VirtualMachine` .

Implements vmware::vcenter::VM.

global::System.Threading.Tasks.Task<string> vmware::vcenter::VMStub::CreateAsync | ( | vmware.vcenter.VMTypes.CreateSpec | spec,
|  | global::System.Action< vmware.vapi.std.Progress > | _progress,
|  | vmware.vapi.bindings.client.InvocationConfig | _invocationConfig
| ) |  | `[inline]`

Creates a virtual machine.

Exceptions:

  vmware.vapi.std.errors.AlreadyExists | if a virtual machine with the specified name already exists.
  vmware.vapi.std.errors.Error | if the system reports an error while responding to the request.
  vmware.vapi.std.errors.InvalidArgument | if any of the specified parameters are invalid.
  vmware.vapi.std.errors.NotFound | if any of the resources specified in spec could not be found
  vmware.vapi.std.errors.ResourceInaccessible | if a specified resource (eg. host) is not accessible.
  vmware.vapi.std.errors.ResourceInUse | if any of the specified storage addresses (eg. IDE, SATA, SCSI) result in a storage address conflict.
  vmware.vapi.std.errors.ServiceUnavailable | if the system is unable to communicate with a service to complete the request.
  vmware.vapi.std.errors.UnableToAllocateResource | if any of the resources needed to create the virtual machine could not be allocated.
  vmware.vapi.std.errors.Unauthenticated | if the user can not be authenticated.
  vmware.vapi.std.errors.Unauthorized | if the user doesn't have the required privileges.
  vmware.vapi.std.errors.Unsupported | if `guestOS` is not supported for the requested virtual hardware version and spec includes null fields that default to guest-specific values.

Parameters:

  spec | Virtual machine specification.
  _progress | Progress notification call back
  _invocationConfig | Configuration for the method invocation

Returns:
  ID of newly-created virtual machine. The result will be an identifier for the resource type: `VirtualMachine` .

Implements vmware::vcenter::VM.

global::System.Threading.Tasks.Task<string> vmware::vcenter::VMStub::CreateAsync | ( | vmware.vcenter.VMTypes.CreateSpec | spec | ) | `[inline]`

Creates a virtual machine.

Exceptions:

  vmware.vapi.std.errors.AlreadyExists | if a virtual machine with the specified name already exists.
  vmware.vapi.std.errors.Error | if the system reports an error while responding to the request.
  vmware.vapi.std.errors.InvalidArgument | if any of the specified parameters are invalid.
  vmware.vapi.std.errors.NotFound | if any of the resources specified in spec could not be found
  vmware.vapi.std.errors.ResourceInaccessible | if a specified resource (eg. host) is not accessible.
  vmware.vapi.std.errors.ResourceInUse | if any of the specified storage addresses (eg. IDE, SATA, SCSI) result in a storage address conflict.
  vmware.vapi.std.errors.ServiceUnavailable | if the system is unable to communicate with a service to complete the request.
  vmware.vapi.std.errors.UnableToAllocateResource | if any of the resources needed to create the virtual machine could not be allocated.
  vmware.vapi.std.errors.Unauthenticated | if the user can not be authenticated.
  vmware.vapi.std.errors.Unauthorized | if the user doesn't have the required privileges.
  vmware.vapi.std.errors.Unsupported | if `guestOS` is not supported for the requested virtual hardware version and spec includes null fields that default to guest-specific values.

Parameters:

  spec | Virtual machine specification.

Returns:
  ID of newly-created virtual machine. The result will be an identifier for the resource type: `VirtualMachine` .

Implements vmware::vcenter::VM.

void vmware::vcenter::VMStub::Delete | ( | string | vm | ) | `[inline]`

Deletes a virtual machine.

Exceptions:

  vmware.vapi.std.errors.Error | if the system reports an error while responding to the request.
  vmware.vapi.std.errors.NotFound | if the virtual machine is not found.
  vmware.vapi.std.errors.ResourceBusy | if the virtual machine is busy performing another operation.
  vmware.vapi.std.errors.ResourceInaccessible | if the virtual machine's configuration state cannot be accessed.
  vmware.vapi.std.errors.ServiceUnavailable | if the system is unable to communicate with a service to complete the request.
  vmware.vapi.std.errors.Unauthenticated | if the user can not be authenticated.
  vmware.vapi.std.errors.Unauthorized | if the user doesn't have the required privileges.

Parameters:

  vm | Virtual machine identifier. The parameter must be an identifier for the resource type: `VirtualMachine` .

Implements vmware::vcenter::VM.

void vmware::vcenter::VMStub::Delete | ( | string | vm,
|  | global::System.Action< vmware.vapi.std.Progress > | _progress,
|  | vmware.vapi.bindings.client.InvocationConfig | _invocationConfig
| ) |  | `[inline]`

Deletes a virtual machine.

Exceptions:

  vmware.vapi.std.errors.Error | if the system reports an error while responding to the request.
  vmware.vapi.std.errors.NotFound | if the virtual machine is not found.
  vmware.vapi.std.errors.ResourceBusy | if the virtual machine is busy performing another operation.
  vmware.vapi.std.errors.ResourceInaccessible | if the virtual machine's configuration state cannot be accessed.
  vmware.vapi.std.errors.ServiceUnavailable | if the system is unable to communicate with a service to complete the request.
  vmware.vapi.std.errors.Unauthenticated | if the user can not be authenticated.
  vmware.vapi.std.errors.Unauthorized | if the user doesn't have the required privileges.

Parameters:

  vm | Virtual machine identifier. The parameter must be an identifier for the resource type: `VirtualMachine` .
  _progress | Progress notification call back
  _invocationConfig | Configuration for the method invocation

Implements vmware::vcenter::VM.

global::System.Threading.Tasks.Task vmware::vcenter::VMStub::DeleteAsync | ( | string | vm | ) | `[inline]`

Deletes a virtual machine.

Exceptions:

  vmware.vapi.std.errors.Error | if the system reports an error while responding to the request.
  vmware.vapi.std.errors.NotFound | if the virtual machine is not found.
  vmware.vapi.std.errors.ResourceBusy | if the virtual machine is busy performing another operation.
  vmware.vapi.std.errors.ResourceInaccessible | if the virtual machine's configuration state cannot be accessed.
  vmware.vapi.std.errors.ServiceUnavailable | if the system is unable to communicate with a service to complete the request.
  vmware.vapi.std.errors.Unauthenticated | if the user can not be authenticated.
  vmware.vapi.std.errors.Unauthorized | if the user doesn't have the required privileges.

Parameters:

  vm | Virtual machine identifier. The parameter must be an identifier for the resource type: `VirtualMachine` .

Implements vmware::vcenter::VM.

global::System.Threading.Tasks.Task vmware::vcenter::VMStub::DeleteAsync | ( | string | vm,
|  | global::System.Action< vmware.vapi.std.Progress > | _progress,
|  | vmware.vapi.bindings.client.InvocationConfig | _invocationConfig
| ) |  | `[inline]`

Deletes a virtual machine.

Exceptions:

  vmware.vapi.std.errors.Error | if the system reports an error while responding to the request.
  vmware.vapi.std.errors.NotFound | if the virtual machine is not found.
  vmware.vapi.std.errors.ResourceBusy | if the virtual machine is busy performing another operation.
  vmware.vapi.std.errors.ResourceInaccessible | if the virtual machine's configuration state cannot be accessed.
  vmware.vapi.std.errors.ServiceUnavailable | if the system is unable to communicate with a service to complete the request.
  vmware.vapi.std.errors.Unauthenticated | if the user can not be authenticated.
  vmware.vapi.std.errors.Unauthorized | if the user doesn't have the required privileges.

Parameters:

  vm | Virtual machine identifier. The parameter must be an identifier for the resource type: `VirtualMachine` .
  _progress | Progress notification call back
  _invocationConfig | Configuration for the method invocation

Implements vmware::vcenter::VM.

vmware.vcenter.VMTypes.Info vmware::vcenter::VMStub::Get | ( | string | vm | ) | `[inline]`

Returns information about a virtual machine.

Exceptions:

  vmware.vapi.std.errors.Error | if the system reports an error while responding to the request.
  vmware.vapi.std.errors.NotFound | if the virtual machine is not found.
  vmware.vapi.std.errors.ResourceInaccessible | if the virtual machine's configuration state cannot be accessed.
  vmware.vapi.std.errors.ServiceUnavailable | if the system is unable to communicate with a service to complete the request.
  vmware.vapi.std.errors.Unauthenticated | if the user can not be authenticated.
  vmware.vapi.std.errors.Unauthorized | if the user doesn't have the required privileges.

Parameters:

  vm | Virtual machine identifier. The parameter must be an identifier for the resource type: `VirtualMachine` .

Returns:
  Information about the specified virtual machine.

Implements vmware::vcenter::VM.

vmware.vcenter.VMTypes.Info vmware::vcenter::VMStub::Get | ( | string | vm,
|  | global::System.Action< vmware.vapi.std.Progress > | _progress,
|  | vmware.vapi.bindings.client.InvocationConfig | _invocationConfig
| ) |  | `[inline]`

Returns information about a virtual machine.

Exceptions:

  vmware.vapi.std.errors.Error | if the system reports an error while responding to the request.
  vmware.vapi.std.errors.NotFound | if the virtual machine is not found.
  vmware.vapi.std.errors.ResourceInaccessible | if the virtual machine's configuration state cannot be accessed.
  vmware.vapi.std.errors.ServiceUnavailable | if the system is unable to communicate with a service to complete the request.
  vmware.vapi.std.errors.Unauthenticated | if the user can not be authenticated.
  vmware.vapi.std.errors.Unauthorized | if the user doesn't have the required privileges.

Parameters:

  vm | Virtual machine identifier. The parameter must be an identifier for the resource type: `VirtualMachine` .
  _progress | Progress notification call back
  _invocationConfig | Configuration for the method invocation

Returns:
  Information about the specified virtual machine.

Implements vmware::vcenter::VM.

global::System.Threading.Tasks.Task<vmware.vcenter.VMTypes.Info> vmware::vcenter::VMStub::GetAsync | ( | string | vm,
|  | global::System.Action< vmware.vapi.std.Progress > | _progress,
|  | vmware.vapi.bindings.client.InvocationConfig | _invocationConfig
| ) |  | `[inline]`

Returns information about a virtual machine.

Exceptions:

  vmware.vapi.std.errors.Error | if the system reports an error while responding to the request.
  vmware.vapi.std.errors.NotFound | if the virtual machine is not found.
  vmware.vapi.std.errors.ResourceInaccessible | if the virtual machine's configuration state cannot be accessed.
  vmware.vapi.std.errors.ServiceUnavailable | if the system is unable to communicate with a service to complete the request.
  vmware.vapi.std.errors.Unauthenticated | if the user can not be authenticated.
  vmware.vapi.std.errors.Unauthorized | if the user doesn't have the required privileges.

Parameters:

  vm | Virtual machine identifier. The parameter must be an identifier for the resource type: `VirtualMachine` .
  _progress | Progress notification call back
  _invocationConfig | Configuration for the method invocation

Returns:
  Information about the specified virtual machine.

Implements vmware::vcenter::VM.

global::System.Threading.Tasks.Task<vmware.vcenter.VMTypes.Info> vmware::vcenter::VMStub::GetAsync | ( | string | vm | ) | `[inline]`

Returns information about a virtual machine.

Exceptions:

  vmware.vapi.std.errors.Error | if the system reports an error while responding to the request.
  vmware.vapi.std.errors.NotFound | if the virtual machine is not found.
  vmware.vapi.std.errors.ResourceInaccessible | if the virtual machine's configuration state cannot be accessed.
  vmware.vapi.std.errors.ServiceUnavailable | if the system is unable to communicate with a service to complete the request.
  vmware.vapi.std.errors.Unauthenticated | if the user can not be authenticated.
  vmware.vapi.std.errors.Unauthorized | if the user doesn't have the required privileges.

Parameters:

  vm | Virtual machine identifier. The parameter must be an identifier for the resource type: `VirtualMachine` .

Returns:
  Information about the specified virtual machine.

Implements vmware::vcenter::VM.

global::System.Collections.Generic.List<vmware.vcenter.VMTypes.Summary> vmware::vcenter::VMStub::List | ( | vmware.vcenter.VMTypes.FilterSpec | filter | ) | `[inline]`

Returns information about at most 1000 visible (subject to permission checks) virtual machines in vCenter matching the VM.FilterSpec .

Exceptions:

  vmware.vapi.std.errors.InvalidArgument | if the VM.FilterSpec.powerStates field contains a value that is not supported by the server.
  vmware.vapi.std.errors.UnableToAllocateResource | if more than 1000 virtual machines match the VM.FilterSpec .
  vmware.vapi.std.errors.ServiceUnavailable | if the system is unable to communicate with a service to complete the request.
  vmware.vapi.std.errors.Unauthenticated | if the user can not be authenticated.
  vmware.vapi.std.errors.Unauthorized | if the user doesn't have the required privileges.

Parameters:

  filter | Specification of matching virtual machines for which information should be returned. If null, the behavior is equivalent to a VM.FilterSpec with all fields null which means all virtual machines match the filter.

Returns:
  Commonly used information about the virtual machines matching the VM.FilterSpec .

Implements vmware::vcenter::VM.

global::System.Collections.Generic.List<vmware.vcenter.VMTypes.Summary> vmware::vcenter::VMStub::List | ( | vmware.vcenter.VMTypes.FilterSpec | filter,
|  | global::System.Action< vmware.vapi.std.Progress > | _progress,
|  | vmware.vapi.bindings.client.InvocationConfig | _invocationConfig
| ) |  | `[inline]`

Returns information about at most 1000 visible (subject to permission checks) virtual machines in vCenter matching the VM.FilterSpec .

Exceptions:

  vmware.vapi.std.errors.InvalidArgument | if the VM.FilterSpec.powerStates field contains a value that is not supported by the server.
  vmware.vapi.std.errors.UnableToAllocateResource | if more than 1000 virtual machines match the VM.FilterSpec .
  vmware.vapi.std.errors.ServiceUnavailable | if the system is unable to communicate with a service to complete the request.
  vmware.vapi.std.errors.Unauthenticated | if the user can not be authenticated.
  vmware.vapi.std.errors.Unauthorized | if the user doesn't have the required privileges.

Parameters:

  filter | Specification of matching virtual machines for which information should be returned. If null, the behavior is equivalent to a VM.FilterSpec with all fields null which means all virtual machines match the filter.
  _progress | Progress notification call back
  _invocationConfig | Configuration for the method invocation

Returns:
  Commonly used information about the virtual machines matching the VM.FilterSpec .

Implements vmware::vcenter::VM.

global::System.Threading.Tasks.Task<global::System.Collections.Generic.List<vmware.vcenter.VMTypes.Summary> > vmware::vcenter::VMStub::ListAsync | ( | vmware.vcenter.VMTypes.FilterSpec | filter,
|  | global::System.Action< vmware.vapi.std.Progress > | _progress,
|  | vmware.vapi.bindings.client.InvocationConfig | _invocationConfig
| ) |  | `[inline]`

Returns information about at most 1000 visible (subject to permission checks) virtual machines in vCenter matching the VM.FilterSpec .

Exceptions:

  vmware.vapi.std.errors.InvalidArgument | if the VM.FilterSpec.powerStates field contains a value that is not supported by the server.
  vmware.vapi.std.errors.UnableToAllocateResource | if more than 1000 virtual machines match the VM.FilterSpec .
  vmware.vapi.std.errors.ServiceUnavailable | if the system is unable to communicate with a service to complete the request.
  vmware.vapi.std.errors.Unauthenticated | if the user can not be authenticated.
  vmware.vapi.std.errors.Unauthorized | if the user doesn't have the required privileges.

Parameters:

  filter | Specification of matching virtual machines for which information should be returned. If null, the behavior is equivalent to a VM.FilterSpec with all fields null which means all virtual machines match the filter.
  _progress | Progress notification call back
  _invocationConfig | Configuration for the method invocation

Returns:
  Commonly used information about the virtual machines matching the VM.FilterSpec .

Implements vmware::vcenter::VM.

global::System.Threading.Tasks.Task<global::System.Collections.Generic.List<vmware.vcenter.VMTypes.Summary> > vmware::vcenter::VMStub::ListAsync | ( | vmware.vcenter.VMTypes.FilterSpec | filter | ) | `[inline]`

Returns information about at most 1000 visible (subject to permission checks) virtual machines in vCenter matching the VM.FilterSpec .

Exceptions:

  vmware.vapi.std.errors.InvalidArgument | if the VM.FilterSpec.powerStates field contains a value that is not supported by the server.
  vmware.vapi.std.errors.UnableToAllocateResource | if more than 1000 virtual machines match the VM.FilterSpec .
  vmware.vapi.std.errors.ServiceUnavailable | if the system is unable to communicate with a service to complete the request.
  vmware.vapi.std.errors.Unauthenticated | if the user can not be authenticated.
  vmware.vapi.std.errors.Unauthorized | if the user doesn't have the required privileges.

Parameters:

  filter | Specification of matching virtual machines for which information should be returned. If null, the behavior is equivalent to a VM.FilterSpec with all fields null which means all virtual machines match the filter.

Returns:
  Commonly used information about the virtual machines matching the VM.FilterSpec .

Implements vmware::vcenter::VM.

The documentation for this class was generated from the following file:

- VMStub.cs